.sshinit: &sshinit
  - 'which ssh-agent || ( apk add -q openssh-client )'
  - 'mkdir -p -m 0700 ~/.ssh'
  - 'echo -e "Host *\n\tStrictHostKeyChecking no\n\n" > ~/.ssh/config'
  - 'ssh-keyscan gitlab.com >> ~/.ssh/known_hosts'
  - 'eval $(ssh-agent -s)'
  - 'echo "$SSH_KEY" | base64 -d | ssh-add - > /dev/null'

.pkg_install: &pkg_install
  - apk update && apk add
        git
        openssh
        nodejs
        npm
        build-base
        libxtst-dev
        gtk+3.0
        python2
        pkgconfig

.ffmpeg_install: &ffmpeg_install
  - git clone git@gitlab.com:set2meet/ffmpeg.git ffmpeg
  - cp -v ffmpeg/bin/ffmpeg /usr/bin/ && chmod +x /usr/bin/ffmpeg
  - cp -v ffmpeg/bin/ffprobe /usr/bin/ && chmod +x /usr/bin/ffprobe
  - cp -v ffmpeg/bin/qt-faststart /usr/bin/ && chmod +x /usr/bin/qt-faststart

.prep_test: &prep_test
  - npm set unsafe-perm true
  - npm install
  - npm run build

.prep_build: &prep_build
  - npm set unsafe-perm true
  - npm install --production
  - npm run build

.gen_licenses: &gen_licenses
  - git clone git@gitlab.com:set2meet/licenses.git license-repo
  - npx license-report > ${APP}.json
  - chmod +x dev/ci/license-save.sh && dev/ci/license-save.sh "${APP}.json" "license-repo"

#--------------------------------{ pipeline, general }--------------------------------------

image: "alpine:3.12.0"
variables:
  APP: "recording-processing"
stages:
  - test
  - build

test:
  stage: test
  variables:
    SSH_KEY: ${SSH_S2M_DEPLOY_PRIVATE_KEY}
  before_script:
    - *pkg_install
    - *sshinit
  script:
    - *prep_test
    - *ffmpeg_install
    - npm run test
  coverage: /Statements\s+:\s(\d+.?\d+)%/
  artifacts:
    paths:
      - coverage/
    reports:
      cobertura: coverage/cobertura-coverage.xml
      junit: junit.xml
    expire_in: 1 week

build:
  stage: build
  variables:
    SSH_KEY: ${SSH_S2M_DEPLOY_PRIVATE_KEY}
  before_script:
    - *pkg_install
    - *sshinit
  script:
    - *ffmpeg_install
    - *prep_build

build:license:
  stage: build
  variables:
    SSH_KEY: ${SSH_S2M_DEPLOY_PRIVATE_KEY}
    GIT_AUTHOR_NAME: '$GITLAB_USER_LOGIN'
    EMAIL: '$GITLAB_USER_LOGIN@epam.com'
  before_script:
    - *pkg_install
    - *sshinit
  script:
    - *ffmpeg_install
    - *prep_build
    - *gen_licenses
